'use strict';

module.exports = function(karma) {
  karma.set({

    frameworks: [ 'browserify', 'jasmine' ],

    files: [
      'lib/**/*.js',
      'test/**/*Spec.js',
    ],

    reporters: [ 'spec', 'dots', 'coverage' ],

    preprocessors: {
      'test/**/*Spec.js': [ 'browserify' ],
      'lib/**/*.js': [ 'browserify' ]
    },

    browsers: [ 'ChromeHeadless'],

    logLevel: 'LOG_DEBUG',

    singleRun: true,
    autoWatch: false,

    // browserify configuration
    browserify: {
      debug: true,
      transform: [
        [
          'babelify',
          {
            presets: ["es2015"],
            plugins: ["transform-es2015-parameters", "transform-class-properties", "istanbul"]
          }
        ],
        'brfs'
      ]
    },
    coverageReporter: {
      instrumenterOptions: {
        istanbul: { noCompact: true }
      },
      reporters:[
        {type: 'lcov', dir:'coverage/'},
        {type: 'text-summary'}
      ]
    }
  });
};
